<?php

if (!defined("_ECRIRE_INC_VERSION")) return;

function action_editer_classe_dist() {
	$securiser_action = charger_fonction('securiser_action', 'inc');
	$arg = $securiser_action();

		if (!$id_classe = intval($arg)) {
		if ($arg != 'oui') {
			include_spip('inc/headers');
			redirige_url_ecrire();
		}
		$id_classe = insert_classe();
	}

	if ($id_classe) $err = revisions_classes($id_classe);
	return array($id_classe,$err);
}


function insert_classe() {
	$champs = array(
		'titre' => _T('classes:item_nouvelle_classe')
	);
	
	// Envoyer aux plugins
	$champs = pipeline('pre_insertion', array(
		'args' => array(
			'table' => 'spip_classes',
		),
		'data' => $champs
	));
	
	$id_classe = sql_insertq("spip_classes", $champs);
	return $id_classe;
}

function revisions_classes($id_classe, $c=false) {

	if ($c === false) {
		$c = array();
		foreach (array('titre', 'descriptif','id_zone') as $champ) {
			if (($a = _request($champ)) !== null) {
				$c[$champ] = $a;
			}
		}
	}
	
function accesrestreint_revision_classe_objets_lies($classes,$ids,$type,$operation = 'add'){
	$in = "";
	if ($classes){
		$in = sql_in('id_classe',$classes);
	}
	$liste = sql_allfetsel('id_classe','spip_classes',$in);
	foreach($liste as $row){
		if ($operation=='del'){
			// on supprime les ids listes
			sql_delete("spip_classes_{$type}s",array("id_classe=".intval($row['id_classe']),sql_in("id_$type",$ids)));			
		}
		else {
			if (!$ids) $ids = array();
			elseif (!is_array($ids)) $ids = array($ids);
			// si c'est une affectation exhaustive, supprimer les existants qui ne sont pas dans ids
			// si c'est un ajout, ne rien effacer
			if ($operation=='set')
				sql_delete("spip_classes_{$type}s",array("id_classe=".intval($row['id_classe']),sql_in("id_$type",$ids,"NOT")));
			$deja = array_map('reset',sql_allfetsel("id_$type","spip_classes_{$type}s","id_classe=".intval($row['id_classe'])));
			$add = array_diff($ids,$deja);
			foreach ($add as $id) {
				if (autoriser('affecterclasse',$type,$id,null,array('id_classe'=>$row['id_classe'])))
					sql_insertq("spip_classes_{$type}s",array('id_classe'=>$row['id_classe'],"id_$type"=>intval($id)));
			}
		}
	}	
}
	
	include_spip('inc/modifier');
	modifier_contenu('classe', $id_classe, array(
			'nonvide' => array('titre' => _T('info_sans_titre')),
			'invalideur' => "id='id_classe/$id_classe'"
		),
		$c);
}
?>
